###########################################################################
# Copyright (c) 2018- Franco (nextime) Lanza <franco@nexlab.it>
#
# Penguidom System client Daemon "penguidomd"  [https://git.nexlab.net/domotika/Penguidom]
#
# This file is part of penguidom.
#
# penguidom is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from twisted.web import client
from zope.interface import implements
from twisted import cred
import twisted.cred.portal
import twisted.cred.credentials
import twisted.cred.checkers
import twisted.cred.error
import logging
from twisted.internet import defer
from nexlibs.utils import genutils
import os, sys

log = logging.getLogger("Webgui")

USERFILE = os.path.join(os.path.abspath(os.path.dirname(sys.argv[0])), 'conf', 'users.conf')

class mindFactory(object):

   loginsaved = False

   def __init__(self, request, credential):
      self.request = request
      self.credential = credential
      self.args = self.request.args



class clientAuth(object):

   implements(cred.checkers.ICredentialsChecker)

   credentialInterfaces = (
      cred.credentials.IUsernamePassword,
   )

   users = {}
   def __init__(self):
      with open(USERFILE) as fp:  
         for cnt, line in enumerate(fp):
            if not line.startswith('#') and len(line) > 0:
               try:
                  l = line.split(':')
                  self.users[l[0]] = {'salt': l[1], 'hash': l[2].rstrip("\r\n")}
               except:
                  pass

   def checkAuth(self, usr, pwd):
      log.debug("CheckAuth for "+str(usr))
      if usr in self.users.keys():
         return defer.succeed(((genutils.hashPwd256("".join([self.users[usr]['salt'], pwd])) == self.users[usr]['hash']) or (pwd == self.users[usr]['hash'])))
      return defer.succeed(False)
      
   def getAuth(self, usr, pwd):
      log.debug("getAuth for "+str(usr))
      return self.checkAuth(usr, pwd)

   def requestAvatarId(self, c):
      log.debug('requestAvatarId: '+str(c.username))
      return self.checkAuth(c.username, c.password).addCallback(
         self.AvatarResults, c)

   def AvatarResults(self, res, c):
      log.debug("AvatarResults "+str(res)+" "+str(c.username))
      if res:
         c.salt = self.users[c.username]["salt"]
         c.hash = self.users[c.username]["hash"]
         return defer.succeed([c, res])
      raise cred.error.UnauthorizedLogin()



def getUserLine(user):
   with open(USERFILE) as fp:
      for cnt, line in enumerate(fp):
         if line.startswith(user):
            try:
               l = line.split(':')
               return {'user': l[0], 'salt': l[1], 'hash': l[2].rstrip("\r\n")}
            except: 
               pass
   return False
